/*!
    \file  MoIp.h
    \brief IPvgRNX wb_

    Copyright (c) 2004 Yamami
    All rights reserved.
    License=MIT/X Licnese

    \author  Yamami 
    \version $Revision: 1.1 $
    \date   create:2004/09/20 update:$Date: 2004/09/20 15:29:03 $
*/
#ifndef _MONA_MOIP_
#define _MONA_MOIP_

#include <sys/types.h>
#include <sys/HashMap.h>
#include <monapi.h>

#include "MoPacUtl.h"
#include "MonesDefine.h"
#include "AbstractMonic.h"


// Yamami ??̐錾łH
/*! 
 *  \struct IP_HEADER
 *  \brief IPwb_\
 */
typedef struct{
    byte  verhead;  /* o[WAwb_B */
    byte  tos;      /* TOS. */
    word len;       /* g[^B */
    word id;        /* ʔԍB */
    word frag;      /* tOAtOgItZbgB */
    byte  ttl;      /* Time to Live. */
    byte  prot;     /* vgRԍB */
    word chksum;    /* wb_`FbNTB */
    dword srcip;        /* 茳IPB */
    dword dstip;        /* IPB */
    char     data[0];
}IP_HEADER;


enum{
    IP_HEAD_VERSION=4<<4,

    IP_HEAD_FRAG_ON= 0x2000,    /* tOgf[^tOB */
    IP_HEAD_FRAG_NOT=0x4000,    /* tOgstOB */
};

/*! 
 *  \struct TRANS_BUF_INFO
 *  \brief IPMobt@\
 */
typedef struct{
    char  *data[3];     /* Mt[AhXB */
    int    size[3];     /* f[^t[TCYB */
    word type;        /* t[^CvB */
    dword  ipType;      /* IPvgR^CvB */
}TRANS_BUF_INFO;


/*!
    MoIp class
*/
class MoIp
{
    
  public:
    
    //RXgN^
    MoIp();
    ~MoIp();
    void initIp(AbstractMonic*);

    int receiveIp(IP_HEADER*);
    int transIp(TRANS_BUF_INFO*, dword , byte , int );

  private:

    //NIChCo
    AbstractMonic* insAbstractNic;

};

#endif
